diff --git a/game/core/src/main/java/net/minecraft/core/entity/Mob.java b/game/core/src/main/java/net/minecraft/core/entity/Mob.java
index 6f73ebaa1..1295c8448 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/Mob.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/Mob.java
@@ -757,6 +757,29 @@ public abstract class Mob extends Entity {
             if (this.horizontalCollision && isFree(this.xd, ((this.yd + 0.6D) - this.y) + d1, this.zd)) {
                 this.yd = 0.3D;
             }
+        } else if (isInAcid()) {
+            double d = this.y;
+
+            moveRelative(moveStrafing, moveForward, 0.01F);
+            move(this.xd, this.yd, this.zd);
+
+            this.xd *= 0.5D;
+            this.yd *= 0.5D;
+            this.zd *= 0.5D;
+
+            this.yd -= 0.01D;
+
+            int blockX = MathHelper.floor(this.x);
+            int blockY = MathHelper.floor(this.y - this.heightOffset);
+            int blockZ = MathHelper.floor(this.z);
+            Block<?> b = this.world.getBlock(blockX, blockY, blockZ);
+
+            float depth;
+            depth = 1 - (float) b.getBlockBoundsFromState(this.world, blockX, blockY, blockZ).maxY();
+
+            if (this.horizontalCollision && isFree(this.xd, ((this.yd + depth + 0.2) - this.y) + d, this.zd)) {
+                this.yd = 0.2D;
+            }
         } else if (canSkate() && BlockTags.SKATEABLE.appliesTo(floorBlock)) {
             this.muteStepSounds = true;
             this.isSkating = true;
@@ -794,7 +817,7 @@ public abstract class Mob extends Entity {
                 movementScale = 0.5460001F;
                 if (BlockTags.OVERRIDE_FRICTION.appliesTo(floorAboveBlock)) {
                     movementScale = floorAboveBlock.friction * 0.91F;
-                } else if (floorBlock != null) {
+                } else {
                     movementScale = floorBlock.friction * 0.91F;
                 }
             }
@@ -940,11 +963,14 @@ public abstract class Mob extends Entity {
         }
         boolean inWater = isInWater();
         boolean inLava = isInLava();
+        boolean inAcid = isInAcid();
         if (this.isJumping) {
             if (inWater) {
                 this.yd += 0.04D;
             } else if (inLava) {
                 this.yd += 0.04D;
+            } else if (inAcid) {
+                this.yd += 0.02D;
             } else if (this.onGround) {
                 jump();
             }
@@ -1034,7 +1060,8 @@ public abstract class Mob extends Entity {
         }
         boolean inWater = isInWater();
         boolean inLava = isInLava();
-        if (inWater || inLava) {
+        boolean inAcid = isInAcid();
+        if (inWater || inLava || inAcid) {
             this.isJumping = this.random.nextFloat() < 0.8F;
         }
     }
@@ -1067,7 +1094,7 @@ public abstract class Mob extends Entity {
         return this.currentTarget;
     }
 
-    private float rotationLerp(float f, float f1, float f2) // Was called rotLerp in the b1.2 leak
+    protected float rotationLerp(float f, float f1, float f2) // Was called rotLerp in the b1.2 leak
     {
         float f3;
         for (f3 = f1 - f; f3 < -180F; f3 += 360F) {
diff --git a/game/core/src/main/java/net/minecraft/core/entity/animal/MobButterfly.java b/game/core/src/main/java/net/minecraft/core/entity/animal/MobButterfly.java
index a38227e25..98a7d3ff3 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/animal/MobButterfly.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/animal/MobButterfly.java
@@ -109,7 +109,7 @@ public class MobButterfly extends MobFlying implements AmbientCreature {
     }
 
     @Override
-    public void push(Entity entity) {
+    public void push(@NotNull Entity entity) {
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/entity/animal/MobFireflyCluster.java b/game/core/src/main/java/net/minecraft/core/entity/animal/MobFireflyCluster.java
index 649d9c0c2..6b05f57ac 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/animal/MobFireflyCluster.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/animal/MobFireflyCluster.java
@@ -249,7 +249,7 @@ public class MobFireflyCluster extends MobFlying
     }
 
     @Override
-    public void push(Entity entity) {
+    public void push(@NotNull Entity entity) {
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/entity/monster/MobGhast.java b/game/core/src/main/java/net/minecraft/core/entity/monster/MobGhast.java
index 89fdb342f..c62b4cf45 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/monster/MobGhast.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/monster/MobGhast.java
@@ -2,24 +2,22 @@ package net.minecraft.core.entity.monster;
 
 import net.minecraft.core.WeightedRandomLootObject;
 import net.minecraft.core.block.tag.BlockTags;
+import net.minecraft.core.entity.EntityItemHoming;
 import net.minecraft.core.entity.MobFlying;
 import net.minecraft.core.entity.player.Player;
-import net.minecraft.core.entity.projectile.ProjectileFireball;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.vehicle.EntityBoat;
+import net.minecraft.core.entity.projectile.ProjectileFireball;
+import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.Items;
-import net.minecraft.core.util.helper.LightIndexHelper;
+import net.minecraft.core.player.gamemode.Gamemodes;
 import net.minecraft.core.util.helper.MathHelper;
-import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.World;
 import net.minecraft.core.util.helper.DamageType;
 import net.minecraft.core.world.pos.TilePos;
 import org.jetbrains.annotations.NotNull;
-import org.joml.Vector3dc;
 import org.joml.primitives.AABBd;
 
-public class MobGhast extends MobFlying
-    implements Enemy {
+public class MobGhast extends MobFlying implements Enemy {
     public static final int DATA_CHARGING = 16;
     public int courseChangeCooldown;
     public double waypointX;
@@ -30,7 +28,6 @@ public class MobGhast extends MobFlying
     public int attackChargeO;
     public int attackCharge;
 
-
     public MobGhast(World world) {
         super(world);
         this.courseChangeCooldown = 0;
@@ -39,10 +36,9 @@ public class MobGhast extends MobFlying
         this.attackChargeO = 0;
         this.attackCharge = 0;
         setTextureIdentifier("minecraft", "ghast");
-        setSize(4F, 7F);
+        setSize(4F, 4.5F);
         this.fireImmune = true;
         this.scoreValue = 1000;
-        MathHelper.aabbGrow(this.bb, 2f, 3f, 2f, this.bb);
         this.mobDrops.add(new WeightedRandomLootObject(Items.GUNPOWDER.getDefaultStack(), 0, 2));
     }
 
@@ -70,8 +66,8 @@ public class MobGhast extends MobFlying
         }
     }
 
+    @Override
     public void tick() {
-        //prevAttackCounter = attackCounter; -uncomment if it still doesn't work
         if (this.world.isClientSide) {
             byte i = this.entityData.getByte(DATA_CHARGING);
             if (i > 0 && this.attackCharge == 0) {
@@ -84,11 +80,12 @@ public class MobGhast extends MobFlying
             if (this.attackCharge >= 20) {
                 this.attackCharge = 20;
             }
-            if (this.attackCharge >= 20 && i == 0) {
+            if (this.attackCharge == 20 && i == 0) {
                 this.world.playSoundAtEntity(null, this, "mob.ghast.fireball", getSoundVolume(), (this.random.nextFloat() - this.random.nextFloat()) * 0.2F + 1.0F);
                 this.attackCharge = -40;
             }
         }
+
         super.tick();
     }
 
@@ -96,86 +93,99 @@ public class MobGhast extends MobFlying
     protected void updateAI() {
         if (!this.world.isClientSide && !this.world.getDifficulty().canHostileMobsSpawn()) {
             remove();
+            return;
         }
         tryToDespawn();
-        this.attackChargeO = this.attackCharge;
+
         double d = this.waypointX - this.x;
         double d1 = this.waypointY - this.y;
         double d2 = this.waypointZ - this.z;
-        double d3 = MathHelper.sqrt(d * d + d1 * d1 + d2 * d2);
-        if (d3 < 1.0D || d3 > 60D) {
-            this.waypointX = this.x + (double) ((this.random.nextFloat() * 2.0F - 1.0F) * 16F);
-            this.waypointY = this.y + (double) ((this.random.nextFloat() * 2.0F - 1.0F) * 16F);
-            this.waypointZ = this.z + (double) ((this.random.nextFloat() * 2.0F - 1.0F) * 16F);
+        double d3 = d * d + d1 * d1 + d2 * d2;
+
+        if (d3 < 1.0D || d3 > 3600.0D) {
+            this.waypointX = this.x + (double)((this.random.nextFloat() * 2.0F - 1.0F) * 16.0F);
+            this.waypointY = this.y + (double)((this.random.nextFloat() * 2.0F - 1.0F) * 16.0F);
+            this.waypointZ = this.z + (double)((this.random.nextFloat() * 2.0F - 1.0F) * 16.0F);
         }
+
         if (this.courseChangeCooldown-- <= 0) {
             this.courseChangeCooldown += this.random.nextInt(5) + 2;
-            if (isCourseTraversable(this.waypointX, this.waypointY, this.waypointZ, d3)) {
-                this.xd += (d / d3) * 0.1D;
-                this.yd += (d1 / d3) * 0.1D;
-                this.zd += (d2 / d3) * 0.1D;
+            d3 = MathHelper.sqrt(d3);
+            if (this.isCourseTraversable(this.waypointX, this.waypointY, this.waypointZ, d3)) {
+                this.xd += d / d3 * 0.1D;
+                this.yd += d1 / d3 * 0.1D;
+                this.zd += d2 / d3 * 0.1D;
             } else {
                 this.waypointX = this.x;
                 this.waypointY = this.y;
                 this.waypointZ = this.z;
             }
         }
-        if (this.targetedEntity != null && this.targetedEntity.removed) {
-            this.targetedEntity = null;
-        }
+
         if (this.targetedEntity == null || this.aggroCooldown-- <= 0) {
-            this.targetedEntity = this.world.getClosestPlayerToEntity(this, 100D);
-            if (this.targetedEntity != null && !((Player) this.targetedEntity).getGamemode().hasHostileMobs()) {
-                this.targetedEntity = null;
+            Entity potentialTarget = this.world.getClosestPlayerToEntity(this, 100.0D);
+
+            if (potentialTarget instanceof Player p && p.gamemode != Gamemodes.CREATIVE && p.gamemode != Gamemodes.SPECTATOR) {
+                this.targetedEntity = potentialTarget;
             }
+
             if (this.targetedEntity != null) {
                 this.aggroCooldown = 20;
             }
         }
-        double d4 = 64D;
-        if (this.targetedEntity != null && this.targetedEntity.distanceToSqr(this) < d4 * d4) {
-            double d8 = 4D;
-            Vector3dc viewVec = getViewVector(1.0F);
-            assert viewVec != null;
-            double dX = this.targetedEntity.x - this.x;
-            double dY = this.targetedEntity.y - this.y;
-            double dZ = this.targetedEntity.z - this.z;
-            double dist = MathHelper.sqrt(dX * dX + dY * dY + dZ * dZ);
-            double vX = dX + (this.targetedEntity.xd * dist / 7.5d) - viewVec.x() * d8;
-            double vY = dY + (this.targetedEntity.yd * dist / 7.5d) - ((double) (this.bbHeight / 2.0F) + 0.5D);
-            double vZ = dZ + (this.targetedEntity.zd * dist / 7.5d) - viewVec.z() * d8;
-            this.yBodyRot = this.yRot = (-(float) java.lang.Math.atan2(vX, vZ) * 180F) / MathHelper.PI;
-            if (canEntityBeSeen(this.targetedEntity)) {
+
+        double maxAttackDist = 64.0D;
+        if (this.targetedEntity != null && this.targetedEntity.distanceToSqr(this) < maxAttackDist * maxAttackDist) {
+            double tx = this.targetedEntity.x - this.x;
+            double ty = (this.targetedEntity.bb.minY + (double)(this.targetedEntity.bbHeight / 2.0F)) - (this.y + (double)(this.bbHeight / 2.0F));
+            double tz = this.targetedEntity.z - this.z;
+
+            // Calculate where we WANT to look
+            float targetYaw = (-(float)java.lang.Math.atan2(tx, tz) * 180F) / MathHelper.PI;
+
+            // Safely calculate the shortest path to that angle
+            float deltaYaw = targetYaw - this.yRot;
+            while (deltaYaw < -180.0F) deltaYaw += 360.0F;
+            while (deltaYaw >= 180.0F) deltaYaw -= 360.0F;
+
+            this.yRot += deltaYaw * 0.1F;
+            this.yBodyRot = this.yRot;
+
+            if (this.canEntityBeSeen(this.targetedEntity)) {
                 if (this.attackCharge == 10) {
                     this.world.playSoundAtEntity(null, this, "mob.ghast.charge", getSoundVolume(), (this.random.nextFloat() - this.random.nextFloat()) * 0.2F + 1.0F);
                 }
                 this.attackCharge++;
                 if (this.attackCharge == 20) {
                     this.world.playSoundAtEntity(null, this, "mob.ghast.fireball", getSoundVolume(), (this.random.nextFloat() - this.random.nextFloat()) * 0.2F + 1.0F);
-                    ProjectileFireball fireball = new ProjectileFireball(this.world, this, vX, vY, vZ);
-
-                    fireball.x = this.x + viewVec.x() * d8;
-                    fireball.y = this.y + (double) (this.bbHeight / 2.0F) + 0.5D;
-                    fireball.z = this.z + viewVec.z() * d8;
+                    ProjectileFireball fireball = new ProjectileFireball(this.world, this, tx, ty, tz);
                     this.world.entityJoinedWorld(fireball);
                     this.attackCharge = -40;
                 }
             } else if (this.attackCharge > 0) {
                 this.attackCharge--;
-            } else {
-                this.targetedEntity = null;
             }
         } else {
-            this.yBodyRot = this.yRot = (-(float) java.lang.Math.atan2(this.xd, this.zd) * 180F) / MathHelper.PI;
+            if (this.xd * this.xd + this.zd * this.zd > 0.001D) {
+                float targetYaw = (-(float) java.lang.Math.atan2(this.xd, this.zd) * 180F) / MathHelper.PI;
+
+                float deltaYaw = targetYaw - this.yRot;
+                while (deltaYaw < -180.0F) deltaYaw += 360.0F;
+                while (deltaYaw >= 180.0F) deltaYaw -= 360.0F;
+
+                this.yRot += deltaYaw * 0.1F;
+                this.yBodyRot = this.yRot;
+            }
+
             if (this.attackCharge > 0) {
                 this.attackCharge--;
             }
         }
+
         if (!this.world.isClientSide) {
-            byte chargeData = this.entityData.getByte(DATA_CHARGING);
-            byte chargeState = (byte) (this.attackCharge <= 10 ? 0 : 1);
-            if (chargeData != chargeState) {
-                this.entityData.set(DATA_CHARGING, chargeState);
+            byte isCharging = (byte)(this.attackCharge > 10 ? 1 : 0);
+            if (this.entityData.getByte(DATA_CHARGING) != isCharging) {
+                this.entityData.set(DATA_CHARGING, isCharging);
             }
         }
     }
@@ -191,7 +201,6 @@ public class MobGhast extends MobFlying
                 return false;
             }
         }
-
         return true;
     }
 
@@ -245,8 +254,10 @@ public class MobGhast extends MobFlying
     public boolean canSpawnHere() {
         return
             this.world.getDifficulty().canHostileMobsSpawn() &&
-                this.random.nextInt(20) == 0 &&
+                this.random.nextInt(30) == 0 &&
                 BlockTags.NETHER_MOBS_SPAWN.appliesTo(this.world.getBlockType(new TilePos(this.x, this.y - this.heightOffset - 1, this.z))) &&
+                this.world.areBlocksLoaded(this.bb) &&
+                this.world.getCubes(this, this.bb).isEmpty() &&
                 super.canSpawnHere();
     }
 
@@ -261,12 +272,34 @@ public class MobGhast extends MobFlying
     }
 
     @Override
-    public float calcBrightness(float partialTick) {
-        return 1;
-    }
+    public void onDeath(Entity killer) {
+        java.util.List<WeightedRandomLootObject> storedDrops = new java.util.ArrayList<>(this.mobDrops);
+        this.mobDrops.clear();
 
-    @Override
-    public byte calcLightIndex(float partialTick) {
-        return LightIndexHelper.lightIndex2i(15, 15);
+        super.onDeath(killer);
+
+        this.mobDrops.addAll(storedDrops);
+
+        if (!this.world.isClientSide) {
+            for (WeightedRandomLootObject lootObject : storedDrops) {
+                ItemStack dropStack = lootObject.getItemStack(this.random);
+
+                if (dropStack != null && dropStack.stackSize > 0) {
+                    if (killer instanceof Player) {
+                        for (int i = 0; i < dropStack.stackSize; i++) {
+                            ItemStack singleDrop = new ItemStack(dropStack.itemID, 1, dropStack.getMetadata());
+
+                            EntityItemHoming homingItem = new EntityItemHoming(this.world, this.x, this.y, this.z, singleDrop, killer);
+                            homingItem.xd = (this.random.nextFloat() - 0.5F) * 0.8F;
+                            homingItem.yd = this.random.nextFloat() * 0.8F;
+                            homingItem.zd = (this.random.nextFloat() - 0.5F) * 0.8F;
+                            this.world.entityJoinedWorld(homingItem);
+                        }
+                    } else {
+                        this.world.dropItem(new TilePos(this.x, this.y, this.z), dropStack);
+                    }
+                }
+            }
+        }
     }
-}
+}
\ No newline at end of file
diff --git a/game/core/src/main/java/net/minecraft/core/entity/player/Player.java b/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
index b5ba3bd35..bb0386cfb 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
@@ -35,9 +35,11 @@ import net.minecraft.core.enums.ArtType;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.enums.EnumSleepStatus;
 import net.minecraft.core.item.Item;
-import net.minecraft.core.item.ItemBucket;
+import net.minecraft.core.item.ItemArmor;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.Items;
+import net.minecraft.core.item.tool.ItemTool;
+import net.minecraft.core.item.tool.ItemToolShears;
 import net.minecraft.core.item.tool.ItemToolSword;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.net.command.TextFormatting;
@@ -47,6 +49,7 @@ import net.minecraft.core.player.inventory.container.Container;
 import net.minecraft.core.player.inventory.container.ContainerInventory;
 import net.minecraft.core.player.inventory.menu.MenuAbstract;
 import net.minecraft.core.player.inventory.menu.MenuInventory;
+import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.DamageType;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.MathHelper;
@@ -58,7 +61,6 @@ import net.minecraft.core.world.chunk.ChunkCoordinates;
 import net.minecraft.core.world.chunk.provider.ChunkProvider;
 import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
-import net.minecraft.core.world.type.tag.WorldTypeTags;
 import net.minecraft.core.world.weather.Weathers;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
@@ -131,6 +133,15 @@ public abstract class Player
     public int lastRenderTick = 0;
     public float wobbleTimer = 0;
 
+    public static final int ACID_CYCLE_MAX = 10;
+    private static final int ACID_POST_EXIT_DRAIN_TICKS = 20;
+    private static final int ACID_EXIT_BUFFER = 2;
+
+    private int acidMeltTicks;
+    private int acidExitDelayLeft;
+    private int acidPostExitDrainTicksLeft;
+    private int acidPostExitPeak;
+
     public final PlayerConfig playerConfig = new PlayerConfig();
 
     public Player(World world) {
@@ -252,6 +263,13 @@ public abstract class Player
     public void tick() {
         if (this.world.getDimension() == Dimension.NETHER) {
             addStat(Achievements.ENTER_NETHER, 1);
+            if (random.nextInt(20) == 0) {
+                int distance = 50;
+                world.playSoundEffect(this, SoundCategory.CAVE_SOUNDS, this.x + distance, this.y, this.z + distance, "ambient.cave.cave", 1.0F, 0.01F);
+                world.playSoundEffect(this, SoundCategory.CAVE_SOUNDS, this.x - distance, this.y, this.z - distance, "ambient.cave.cave", 1.0F, 0.01F);
+                world.playSoundEffect(this, SoundCategory.CAVE_SOUNDS, this.x + distance, this.y, this.z - distance, "ambient.cave.cave", 1.0F, 0.01F);
+                world.playSoundEffect(this, SoundCategory.CAVE_SOUNDS, this.x - distance, this.y, this.z + distance, "ambient.cave.cave", 1.0F, 0.01F);
+            }
         }
 
         this.xdO = this.xd;
@@ -374,6 +392,8 @@ public abstract class Player
         this.cameraVelocityOld = this.cameraVelocity;
         super.onLivingUpdate();
 
+        acidTick();
+
         this.speed = this.baseSpeed;
         this.flySpeed = this.baseFlySpeed;
         if (isSprinting()) {
@@ -411,6 +431,202 @@ public abstract class Player
                 }
             }
         }
+
+        AABBd feetBox = new AABBd(this.bb.minX, this.bb.minY - 0.1D, this.bb.minZ, this.bb.maxX, this.bb.minY + 0.1D, this.bb.maxZ);
+        List<Entity> platforms = this.world.getEntitiesWithinAABBExcludingEntity(this, feetBox);
+
+        for (int i = 0; i < platforms.size(); i++) {
+            Entity platform = platforms.get(i);
+
+            if (platform instanceof MobGhast) continue;
+
+            if (platform.hasCollision() && this.bb.minY >= platform.bb.maxY - 0.25D) {
+
+                if (this.yd < 0.0D) {
+                    this.yd = 0.0D;
+                }
+                this.fallDistance = 0.0F;
+
+                double deltaX = platform.x - platform.xo;
+                double deltaZ = platform.z - platform.zo;
+                double snapY = platform.bb.maxY - this.bb.minY;
+
+                this.move(deltaX, snapY, deltaZ);
+
+                this.onGround = true;
+                break;
+            }
+        }
+    }
+
+    public void acidTick() {
+        if (!getGamemode().hasToolDurability()) {
+            this.acidMeltTicks = 0;
+            this.acidExitDelayLeft = 0;
+            this.acidPostExitPeak = 0;
+            this.acidPostExitDrainTicksLeft = 0;
+            return;
+        }
+
+        final boolean physicallyInAcid = isInAcid();
+        final int meltRate = Math.max(1, this.world.getGameRuleValue(GameRules.ACID_MELT_RATE));
+        final boolean shouldTickRate = (this.tickCount % meltRate == 0);
+
+        if (physicallyInAcid) {
+            this.acidExitDelayLeft = ACID_EXIT_BUFFER;
+            this.acidPostExitDrainTicksLeft = ACID_POST_EXIT_DRAIN_TICKS;
+            this.acidPostExitPeak = 0;
+        }
+
+        final boolean applyAcidMeltAndDamage = physicallyInAcid || this.acidExitDelayLeft > 0;
+
+        if (applyAcidMeltAndDamage) {
+            if (!physicallyInAcid && this.acidExitDelayLeft > 0) {
+                this.acidExitDelayLeft--;
+                if (this.acidExitDelayLeft == 0) {
+                    this.acidPostExitPeak = this.acidMeltTicks;
+                }
+            }
+
+            if (shouldTickRate) {
+                this.acidMeltTicks = Math.min(this.acidMeltTicks + 1, ACID_CYCLE_MAX);
+
+                if (!this.world.isClientSide && isAlive()) {
+                    processAcidDamageAndParticles();
+                }
+            }
+        } else if (this.acidMeltTicks > 0) {
+            if (this.acidPostExitDrainTicksLeft > 0) {
+                this.acidPostExitDrainTicksLeft--;
+                if (this.acidPostExitDrainTicksLeft <= 0) {
+                    this.acidMeltTicks = 0;
+                    this.acidPostExitPeak = 0;
+                }
+            }
+        }
+    }
+
+    /** True while physically in acid or during {@link #ACID_EXIT_BUFFER} post-exit melt/damage ticks. */
+    public boolean isEffectiveInAcid() {
+        return isInAcid() || this.acidExitDelayLeft > 0;
+    }
+
+    private void processAcidDamageAndParticles() {
+        final int acidIntensity = this.acidMeltTicks;
+        boolean meltedAny = false;
+
+        for (int i = 0; i < this.inventory.mainInventory.length; i++) {
+            final @Nullable ItemStack stack = this.inventory.mainInventory[i];
+            if (stack == null || !isMeltableHeldTool(stack)) {
+                continue;
+            }
+
+            stack.damageItem(getAcidMeltDamage(stack, acidIntensity), this);
+            if (stack.stackSize <= 0) {
+                this.inventory.mainInventory[i] = null;
+            }
+            meltedAny = true;
+        }
+
+        for (int i = 0; i < getNumArmorSlots(); i++) {
+            final @Nullable HumanArmorShape armorSlot = getArmorSlotByIndex(i);
+            if (armorSlot == null) {
+                continue;
+            }
+
+            final @Nullable ItemStack armorItem = getItemInArmorSlot(armorSlot);
+            if (armorItem == null) {
+                continue;
+            }
+
+            damageArmor(getAcidMeltDamage(armorItem, acidIntensity), armorSlot);
+            meltedAny = true;
+        }
+
+        int acidExposureDamage = getAcidExposureArmorSlotCount();
+        if (acidExposureDamage > 0) {
+            hurt(null, acidExposureDamage, DamageType.GENERIC);
+        }
+
+        if (meltedAny || acidExposureDamage > 0) {
+            float fizzPitch = 0.6F + this.random.nextFloat() * 0.25F;
+            float bubblePitch = 0.7F + this.random.nextFloat() * 0.2F;
+            this.world.playSoundAtEntity(null, this, "random.fizz", 0.35F, fizzPitch);
+            this.world.playSoundAtEntity(null, this, "tile.acidbubble", 0.4F, bubblePitch);
+
+            for (int i = 0; i < 6; i++) {
+                double offX = (this.random.nextDouble() - 0.5D) * (double) this.bbWidth;
+                double offY = this.random.nextDouble() * (double) this.bbHeight;
+                double offZ = (this.random.nextDouble() - 0.5D) * (double) this.bbWidth;
+                this.world.spawnParticle("acidBoiling", this.x + offX, this.bb.minY + offY, this.z + offZ, 0.0F, 0.02F, 0.0F, 0, false);
+            }
+        }
+    }
+
+    public boolean shouldShowAcidVisualEffects() {
+        return isEffectiveInAcid() || this.acidMeltTicks > 0;
+    }
+
+    public int getAcidHudBarFillTicks() {
+        if (isEffectiveInAcid() || this.acidPostExitPeak == 0) {
+            return this.acidMeltTicks;
+        }
+        if (this.acidPostExitDrainTicksLeft <= 0) {
+            return 0;
+        }
+
+        return (this.acidPostExitPeak * this.acidPostExitDrainTicksLeft) / ACID_POST_EXIT_DRAIN_TICKS;
+    }
+
+    private int getAcidExposureArmorSlotCount() {
+        int count = 0;
+        for (int i = 0; i < getNumArmorSlots(); i++) {
+            final @Nullable HumanArmorShape armorSlot = getArmorSlotByIndex(i);
+            if (armorSlot == null) {
+                continue;
+            }
+            final @Nullable ItemStack stack = getItemInArmorSlot(armorSlot);
+            if (!isHumanArmorItemCoveringSlot(stack)) {
+                count++;
+            }
+        }
+        return Math.max(0, count - 1);
+    }
+
+    private static boolean isHumanArmorItemCoveringSlot(final @Nullable ItemStack stack) {
+        if (stack == null) {
+            return false;
+        }
+        if (!(stack.getItem() instanceof ItemArmor<?> armor)) {
+            return false;
+        }
+        return armor.getArmorShape() instanceof HumanArmorShape;
+    }
+
+    private boolean isMeltableHeldTool(final @NotNull ItemStack stack) {
+        final @NotNull Item item = stack.getItem();
+        return item instanceof ItemTool || item instanceof ItemToolSword || item instanceof ItemToolShears;
+    }
+
+    private int getAcidMeltDamage(final @NotNull ItemStack stack, final int acidIntensity) {
+        if (!stack.isItemStackDamageable()) {
+            return 1;
+        }
+
+        final int base = Math.max(1, (int) Math.ceil(Math.sqrt(stack.getMaxDamage()) / 10.0D));
+
+        final int tier = Math.min(ACID_CYCLE_MAX, Math.max(1, acidIntensity));
+        if (tier < 2 || ACID_CYCLE_MAX < 2) {
+            return base;
+        }
+
+        float progress = (float) (tier - 1) / (float) (ACID_CYCLE_MAX - 1);
+
+        float curve = (float) Math.sqrt(progress);
+
+        final float multiplier = 1.0F + (curve * 0.45F);
+
+        return Math.max(1, (int) Math.ceil(base * multiplier));
     }
 
     @Override
@@ -467,8 +683,8 @@ public abstract class Player
         } else if (UUID_SHIGN.equals(this.uuid) || this.username.equals("ShignBright")) {
             dropItem(new ItemStack(Items.SIGN_PAINTED, 1, DyeColor.PINK.itemMeta), true);
         } else if ((UUID_MELON.equals(this.uuid) || this.username.equals("MelonMojito")) || (UUID_WATERMELON.equals(this.uuid) || this.username.equals("WatermelonMojito"))) {
-            ItemStack melon = new ItemStack(Blocks.PUMPKIN, 1, this.random.nextInt(Short.MAX_VALUE / 2) + 1);
-            melon.setCustomName("Melon");
+            ItemStack melon = new ItemStack(Blocks.PUMPKIN, 1);
+            melon.setCustomName("Melon Block?");
             melon.setCustomColor((byte) TextFormatting.LIME.id);
             dropItem(melon, true);
         }
@@ -659,7 +875,7 @@ public abstract class Player
     }
 
     @Override
-    public void push(Entity entity) {
+    public void push(@NotNull Entity entity) {
         if (this.noPhysics || !getGamemode().canInteract()) return;
         super.push(entity);
     }
@@ -1421,6 +1637,45 @@ public abstract class Player
         }
     }
 
+
+    //TODO Need to implement a native solution for distance/player oriented functionality
+    /**
+     * Handles the incoming ping from a nearby Thermal Vent.
+     * Categorizes the player into Close, Medium, or Far range based on maxRadius,
+     * playing a different sound for each tier.
+     */
+    public void handleThermalPing(Player player, double ventCoordinateX, double ventCoordinateY, double ventCoordinateZ, double maxRadius) {
+        double distanceSquared = this.distanceToSqr(ventCoordinateX, ventCoordinateY, ventCoordinateZ);
+        double distance = Math.sqrt(distanceSquared);
+
+        double oneFifthOfRadius = maxRadius * 0.2;
+        double threeFifthsOfRadius = maxRadius * 0.6;
+
+        float randomizedPitch = 0.8F + (this.world.rand.nextFloat() - this.world.rand.nextFloat()) * 0.45F;
+
+        if (distance <= oneFifthOfRadius) {
+            this.world.playSoundEffect(player, SoundCategory.WORLD_SOUNDS,
+                ventCoordinateX, ventCoordinateY, ventCoordinateZ,
+            "tile.crumble", 20.0F, randomizedPitch);
+            this.world.playSoundEffect(player, SoundCategory.WORLD_SOUNDS,
+                ventCoordinateX, ventCoordinateY, ventCoordinateZ,
+            "tile.deepboom", 20.0F, randomizedPitch);
+        }
+        else if (distance <= threeFifthsOfRadius) {
+            this.world.playSoundEffect(player, SoundCategory.WORLD_SOUNDS,
+                ventCoordinateX, ventCoordinateY, ventCoordinateZ,
+            "tile.deepcrumble", 20.0F, randomizedPitch);
+            this.world.playSoundEffect(player, SoundCategory.WORLD_SOUNDS,
+                ventCoordinateX, ventCoordinateY, ventCoordinateZ,
+            "tile.deepquietboom", 20.0F, randomizedPitch);
+        }
+        else {
+            this.world.playSoundEffect(player, SoundCategory.WORLD_SOUNDS,
+                ventCoordinateX, ventCoordinateY, ventCoordinateZ,
+            "tile.deepquietboom", 20.0F, randomizedPitch);
+        }
+    }
+
     @Override
     public boolean canBreatheUnderwater() {
         return this.gamemode.hasInvulnerablePlayer();
